indent = 0

def generate(size, outfile):
    with open(outfile, "w") as f:
        gen_init(size, f)
        gen_parameters(size, f)
        gen_invariants(size, f)
        gen_initial(size, f)
        gen_subcomponents(size, f)
        gen_connections(size, f)
        gen_reconfigurations(size, f)
        gen_end(size, f)

def get_src_dst(size):
	return ("a"+str(size//2), "b0")

def gen_init(sz, f):
    write(f, "system implementation sys.impl\n")

def gen_parameters(sz, f):
    global indent
    indent += 1
    write(f, "parameters\n")
    indent += 1
    for i in range(0, sz):
        write(f, "A"+str(i)+": set of indices;\n")
    for i in range(0, sz):
        write(f, "B"+str(i)+": set of indices;\n")
    write(f, "C: set of indices;\n")
    indent -= 2
    write(f, "\n")

def gen_invariants(sz, f):
    pass

def gen_initial(sz, f):
    pass

def gen_subcomponents(sz, f):
    global indent
    indent += 1
    write(f, "subcomponents\n")
    indent += 1
    for i in range(0, sz):
        write(f, "a"+str(i)+": set indexed by A"+ str(i)+";\n")
    for i in range(0, sz):
        write(f, "b"+str(i)+": set indexed by B"+ str(i)+";\n")
    write(f, "c: set indexed by C;\n")
    indent -= 2
    write(f, "\n")

def gen_connections(sz, f):
    global indent
    indent += 1
    write(f, "connections\n")
    indent += 1
    write(f, "a0[x] -> c[y] for x in A0, y in C;\n");
    write(f, "c[y] -> a0[x] for x in A0, y in C;\n");
    write(f, "b0[x] -> c[y] for x in B0, y in C;\n");
    write(f, "c[y] -> b0[x] for x in B0, y in C;\n");
    f.write("\n");
    for i in range(0, sz-1):
        write(f, "a"+str(i+1)+"[x] -> a"+str(i)+"[y] for "
                 +"x in A"+str(i+1)+", y in A"+str(i)+";\n")
        write(f, "a"+str(i)+"[x] -> a"+str(i+1)+"[y] for "
                 +"x in A"+str(i)+", y in A"+str(i+1)+";\n")
    f.write("\n");
    for i in range(0, sz-1):
        write(f, "b"+str(i+1)+"[x] -> b"+str(i)+"[y] for "
                 +"x in B"+str(i+1)+", y in B"+str(i)+";\n")
        write(f, "b"+str(i)+"[x] -> b"+str(i+1)+"[y] for "
                 +"x in B"+str(i)+", y in B"+str(i+1)+";\n")
    indent -= 2
    write(f, "\n")

def gen_reconfigurations(sz, f):
    global indent
    indent += 1
    write(f, "reconfigurations\n")
    indent += 1
    for i in range(0, sz):
        write(f, "exists(x not in A"+str(i)+", next(A"+str(i)
                 +") = add(A"+str(i)+", x));\n");
    f.write("\n");
    for i in range(0, sz):
        write(f, "exists(x in A"+str(i)+", next(A"+str(i)
                 +") = remove(A"+str(i)+", x));\n");
    f.write("\n");
    for i in range(0, sz):
        write(f, "exists(x not in B"+str(i)+", next(B"+str(i)
                 +") = add(B"+str(i)+", x));\n");
    f.write("\n");
    for i in range(0, sz):
        write(f, "exists(x in B"+str(i)+", next(B"+str(i)
                 +") = remove(B"+str(i)+", x));\n");
    f.write("\n");
    write(f, "exists(x not in C, next(C) = add(C, x));\n");
    write(f, "exists(x in C, next(C) = remove(C, x));\n");
	
    indent -= 2

def gen_end(sz, f):
    write(f, "end sys.impl;\n")

def write(f, s):
    global indent
    for i in range(0, indent):
        f.write("    ")
    f.write(s)
