indent = 0

def generate(size, outfile):
    with open(outfile, "w") as f:
        gen_init(size, f)
        gen_parameters(size, f)
        gen_invariants(size, f)
        gen_initial(size, f)
        gen_subcomponents(size, f)
        gen_connections(size, f)
        gen_reconfigurations(size, f)
        gen_end(size, f)

def get_src_dst(size):
    return ("s", "d")

def gen_init(sz, f):
    write(f, "system implementation sys.impl\n")

def gen_parameters(sz, f):
    global indent
    indent += 1
    write(f, "parameters\n")
    indent += 1
    for i in range(0, sz):
        write(f, "A"+str(i)+": set of indices;\n")
    indent -= 2
    write(f, "\n")

def gen_invariants(sz, f):
    pass

def gen_initial(sz, f):
    pass

def gen_subcomponents(sz, f):
    global indent
    indent += 1
    write(f, "subcomponents\n")
    indent += 1
    write(f, "s: single;\n")
    write(f, "d: single;\n")
    for i in range(0, sz):
        write(f, "a"+str(i)+": set indexed by A"+ str(i)+";\n")
    indent -= 2
    write(f, "\n")

def gen_connections(sz, f):
    global indent
    indent += 1
    write(f, "connections\n")
    indent += 1
    write(f, "s -> a0[0];\n");
    write(f, "a"+str(sz-1)+"["+str(sz-2)+"] -> d;\n");
    f.write("\n");
    for i in range(0, sz):
        write(f, "a"+str(i)+"[x] -> a"+str(i)+"[y] if x < y for "
                 +"x in A"+str(i)+", y in A"+str(i)+";\n")
    f.write("\n");
    for i in range(0, sz-1):
        write(f, "a"+str(i)+"[x] -> a"+str(i+1)+"[y] if x < y for "
                 +"x in A"+str(i)+", y in A"+str(i+1)+";\n")
    write(f, "a"+str(sz-1)+"[x] -> a0[y] if x < y + "+str(sz+1)+" for "
             +"x in A"+str(sz-1)+", y in A0;\n")
    indent -= 2
    write(f, "\n")

def gen_reconfigurations(sz, f):
    global indent
    indent += 1
    write(f, "reconfigurations\n")
    indent += 1
    for i in range(0, sz):
        write(f, "exists(x not in A"+str(i)+", next(A"+str(i)
                 +") = add(A"+str(i)+", x));\n");
        write(f, "exists(x in A"+str(i)+", next(A"+str(i)
                 +") = remove(A"+str(i)+", x));\n");
        f.write("\n");
    indent -= 2

def gen_end(sz, f):
    write(f, "end sys.impl;\n")

def write(f, s):
    global indent
    for i in range(0, indent):
        f.write("    ")
    f.write(s)
